<?php
namespace nur\sery\wip\schema\_assoc;

use nur\sery\wip\schema\_scalar\ScalarResult;
use nur\sery\wip\schema\input\Input;
use nur\sery\wip\schema\Schema;
use nur\sery\wip\schema\types\IType;
use nur\sery\wip\schema\Wrapper;
use nur\sery\wip\schema\WrapperContext;

class AssocWrapperContext extends WrapperContext {
  function __construct(Schema $schema, ?Input $input, $valueKey, ?array $params) {
    parent::__construct($schema, $input, $valueKey, $params);
    $this->arrayType = null;
    $this->arrayResult = null;
  }

  public ?IType $arrayType;
  /** résultat de l'analyse du tableau */
  public ?ScalarResult $arrayResult;

  /** liste des clés valides */
  public array $keys;

  /** @var ?IType[] */
  public array $keyTypes;

  /** @var Wrapper[] */
  public array $keyWrappers;
}
